package me.unurled.sacredrealms.sr.components.clientbuild;

import java.util.HashMap;
import org.bukkit.Location;
import org.bukkit.block.data.BlockData;
import org.jetbrains.annotations.NotNull;

public class ClientBuild {
  private final String name;
  private final HashMap<Location, BlockData> blocks = new HashMap<>();

  public ClientBuild(String name) {
    this.name = name;
  }

  public String getName() {
    return this.name;
  }

  public HashMap<Location, BlockData> getBlocks() {
    return this.blocks;
  }

  public void addBlock(Location loc, BlockData state) {
    this.blocks.put(loc, state);
  }

  public void removeBlock(@NotNull Location loc) {
    this.blocks.remove(loc);
  }

  public void clearBlocks() {
    this.blocks.clear();
  }

  public boolean containsBlock(@NotNull Location loc, @NotNull BlockData data) {
    return this.blocks.containsKey(loc) && this.blocks.get(loc).matches(data);
  }
}
