package me.unurled.sacredrealms.sr.events.player;

import me.unurled.sacredrealms.sr.components.player.SRPlayer;
import org.bukkit.event.Event;
import org.bukkit.event.HandlerList;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.jetbrains.annotations.NotNull;

public class PlayerKillEvent extends Event {

  private static final HandlerList HANDLERS = new HandlerList();
  private final SRPlayer player;
  private final DamageCause cause;

  public PlayerKillEvent(SRPlayer player, DamageCause cause) {
    super(false);
    this.player = player;
    this.cause = cause;
  }

  public static HandlerList getHandlerList() {
    return HANDLERS;
  }

  @Override
  public @NotNull HandlerList getHandlers() {
    return HANDLERS;
  }

  public SRPlayer getPlayer() {
    return player;
  }

  public DamageCause getCause() {
    return cause;
  }
}
